Package ghidra.app.util.bin.format.macho.commands.dyld

# Enum Class RebaseOpcode

java.lang.Object
java.lang.Enum<RebaseOpcode>
ghidra.app.util.bin.format.macho.commands.dyld.RebaseOpcode

All Implemented Interfaces:
  `Serializable`, `Comparable<RebaseOpcode>`, `Constable`

public enum RebaseOpcode extends Enum<RebaseOpcode>
Rebase opcodes

See Also:
  - EXTERNAL_HEADERS/mach-o/loader.h

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `REBASE_OPCODE_ADD_ADDR_IMM_SCALED`
  `REBASE_OPCODE_ADD_ADDR_ULEB`
  `REBASE_OPCODE_DO_REBASE_ADD_ADDR_ULEB`
  `REBASE_OPCODE_DO_REBASE_IMM_TIMES`
  `REBASE_OPCODE_DO_REBASE_ULEB_TIMES`
  `REBASE_OPCODE_DO_REBASE_ULEB_TIMES_SKIPPING_ULEB`
  `REBASE_OPCODE_DONE`
  `REBASE_OPCODE_SET_SEGMENT_AND_OFFSET_ULEB`
  `REBASE_OPCODE_SET_TYPE_IMM`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static RebaseOpcode`
  `forOpcode(int opcode)`
  Gets the `RebaseOpcode` that corresponds to the given opcode value
  `int`
  `getOpcode()`
  Returns the opcode value.
  `static DataType`
  `toDataType()`
  Returns a new data type from this enum.
  `static RebaseOpcode`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static RebaseOpcode[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### REBASE_OPCODE_DONE

    public static final RebaseOpcode REBASE_OPCODE_DONE

  - ### REBASE_OPCODE_SET_TYPE_IMM

    public static final RebaseOpcode REBASE_OPCODE_SET_TYPE_IMM

  - ### REBASE_OPCODE_SET_SEGMENT_AND_OFFSET_ULEB

    public static final RebaseOpcode REBASE_OPCODE_SET_SEGMENT_AND_OFFSET_ULEB

  - ### REBASE_OPCODE_ADD_ADDR_ULEB

    public static final RebaseOpcode REBASE_OPCODE_ADD_ADDR_ULEB

  - ### REBASE_OPCODE_ADD_ADDR_IMM_SCALED

    public static final RebaseOpcode REBASE_OPCODE_ADD_ADDR_IMM_SCALED

  - ### REBASE_OPCODE_DO_REBASE_IMM_TIMES

    public static final RebaseOpcode REBASE_OPCODE_DO_REBASE_IMM_TIMES

  - ### REBASE_OPCODE_DO_REBASE_ULEB_TIMES

    public static final RebaseOpcode REBASE_OPCODE_DO_REBASE_ULEB_TIMES

  - ### REBASE_OPCODE_DO_REBASE_ADD_ADDR_ULEB

    public static final RebaseOpcode REBASE_OPCODE_DO_REBASE_ADD_ADDR_ULEB

  - ### REBASE_OPCODE_DO_REBASE_ULEB_TIMES_SKIPPING_ULEB

    public static final RebaseOpcode REBASE_OPCODE_DO_REBASE_ULEB_TIMES_SKIPPING_ULEB

- ## Method Details

  - ### values

    public static RebaseOpcode[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static RebaseOpcode valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getOpcode

    public int getOpcode()
    Returns the opcode value.
    Returns:
      the opcode value

  - ### toDataType

    public static DataType toDataType()
    Returns a new data type from this enum.
    Returns:
      a new data type from this enum

  - ### forOpcode

    public static RebaseOpcode forOpcode(int opcode)
    Gets the `RebaseOpcode` that corresponds to the given opcode value
    Parameters:
      `opcode` - The opcode value
    Returns:
      The `RebaseOpcode` that corresponds to the given opcode value, or null if it does not exist